*------------------------------------------------------------*
#include <hmg.ch>
*------------------------------------------------------------*
function main()

private cSearchString:=""

REQUEST DBFNSX
SET BROWSESYNC ON
SET DATE ITALIAN

dbUseArea(.T.,"DBFNSX","MUSIC",.F.)
OrdSetFocus(1)
dbGoTop()

DEFINE WINDOW wndMainForm;
   AT 90,90;
   WIDTH 645;
   HEIGHT 403;
   TITLE "Browse Quick Search Demo";
   ON RELEASE DBCloseAll();
   MAIN

DEFINE STATUSBAR
STATUSITEM "Type to QuickSearch"
STATUSITEM " " WIDTH 15
END STATUSBAR

END WINDOW

@ 5,5 BROWSE brsMainBrowse;
   OF wndMainForm;
   WIDTH 620;
   HEIGHT 332;
   HEADERS {"Nummer","Trk","Artiest","Titel"} ;
   WIDTHS {65,35,248,249};
   WORKAREA MUSIC;
   FIELDS {"MUSIC->NR","MUSIC->DTR","MUSIC->ARTIEST","MUSIC->TITEL"};
   JUSTIFY { BROWSE_JTFY_LEFT,BROWSE_JTFY_RIGHT,BROWSE_JTFY_LEFT,BROWSE_JTFY_LEFT}

CREATE EVENT PROCNAME BrowseQuickIndexSearch('wndMainForm','brsMainBrowse')

wndMainForm.Center
wndMainForm.Activate

return NIL
*------------------------------------------------------------*
function BrowseQuickIndexSearch(cWindowName,cBrowseName)

LOCAL nKey, cKey, nOldRec, hWnd:=EventHWND()

IF hWnd==GetProperty(cWindowName,cBrowseName,"Handle")

   nKey:=HMG_GetLastVirtualKeyDown()
   HMG_CleanLastVirtualKeyDown()

   DO CASE

   CASE nKey==VK_UP
      _BrowseUp(cBrowseName,cWindowName)
      cSearchString:=""
      SetProperty(cWindowName,"StatusBar","Item",1,"")
      return 1

   CASE nKey==VK_DOWN
      _BrowseDown(cBrowseName,cWindowName)
      cSearchString:=""
      SetProperty(cWindowName,"StatusBar","Item",1,"")
      return 1

   CASE nKey==VK_HOME
      _BrowseHome(cBrowseName,cWindowName)
      cSearchString:=""
      SetProperty(cWindowName,"StatusBar","Item",1,"")
      return 1

   CASE nKey==VK_END
      _BrowseEnd(cBrowseName,cWindowName)
      cSearchString:=""
      SetProperty(cWindowName,"StatusBar","Item",1,"")
      return 1

   CASE nKey==VK_PRIOR
      _BrowsePrior(cBrowseName,cWindowName)
      cSearchString:=""
      SetProperty(cWindowName,"StatusBar","Item",1,"")
      return 1

   CASE nKey==VK_NEXT
      _BrowseNext(cBrowseName,cWindowName)
      cSearchString:=""
      SetProperty(cWindowName,"StatusBar","Item",1,"")
      return 1

   CASE nKey==VK_ESCAPE
      IF Empty(cSearchString)
         DoMethod(cWindowName,"Release")
         return
      ELSE
         cSearchString:=""
         SetProperty(cWindowName,"StatusBar","Item",1,"")
         return 1
      ENDIF

   CASE EventMSG()==WM_CHAR
      nOldRec:=RecNo()
      cKey:=HMG_GetLastCharacter()
      HMG_CleanLastCharacter()

      IF Asc(cKey)==VK_BACK
         cSearchString:=IIF(len(cSearchString)>1,left(cSearchString,len(cSearchString)-1),"")
      ELSE
         cSearchString:=cSearchString+cKey
      ENDIF

      IF DBSEEK(Upper(cSearchString),.T.)==.T.      // Found !
         SetProperty(cWindowName,cBrowseName,"Value",RecNo())
      ELSE
         cSearchString:=if(len(cSearchString)>1,left(cSearchString,len(cSearchString)-1),"")
         DbGoTo(nOldRec)
         SetProperty(cWindowName,cBrowseName,"Value",nOldRec)
      ENDIF

      SetProperty(cWindowName,"StatusBar","Item",1,iif(empty(cSearchString),"","Quicksearch: "+cSearchString))
      DoMethod(cWindowName,cBrowseName,'Setfocus')
      return 1

   ENDCASE

ENDIF

return
*------------------------------------------------------------*

